<?php
$this->title = 'Настройки оплаты';
error_reporting(E_ALL);
ini_set("display_errors", 1);
if (empty($_SESSION['auth'])):
	header('Location: /auth/');
	exit;
endif;
$err[0] = '';
$tk = new token();
$check_values = new filter();

$get_shop = $db->row("SELECT * FROM shop WHERE domain = ? AND id_user = ?", array($_GET['shop'], $_SESSION['auth']['id']));
$get_webmoney = $db->row("SELECT * FROM payment_webmoney WHERE id_shop = ?", array($get_shop['id']));
$get_qiwi = $db->row("SELECT * FROM payment_qiwi WHERE id_shop = ?", array($get_shop['id']));
$get_yandex = $db->row("SELECT * FROM payment_yandex WHERE id_shop = ?", array($get_shop['id']));

// Проверяем и устанавливаем qiwi
if (
	!$get_qiwi and
	!empty($_POST['token']) and 
	$tk->check($_POST['token']) and 
	!empty($_POST['qiwi_password']) and 
	$check_values->check('qiwi_purse','post','regexp','~^\+[0-9]{5,25}|[0-9]{5,25}$~')
	):

	$qiwi_purse = str_replace("+", "", $_POST['qiwi_purse']);

	try
	{
		$qiwi = new QIWI($qiwi_purse,$_POST['qiwi_password']);
	    $auth_qiwi = $qiwi->check_qiwi($qiwi_purse,$_POST['qiwi_password']);
	} catch (Exception $e) {
	    
	    $auth_qiwi = false;
	    //echo 'Сообщение: '   . $e->getMessage() . '<br />';
	}


	// Авторизация пройдена, записываем в базу
	if ($auth_qiwi):
		$insert_qiwi = $db->insert("INSERT INTO payment_qiwi (id_shop, login, password) VALUES (?, ?, ?)", array($get_shop['id'], $qiwi_purse, $_POST['qiwi_password']));
		header('Location: /shops/settings/'.$_GET['shop'].'/payment/');
	else:
		$err[0] = 'Неверный номер телефона или пароль';
	endif;
	// Авторизация пройдена, записываем в базу


endif;
// Проверяем и устанавливаем qiwi

// Удаляем qiwi
if (
	!empty($_GET['action']) and 
	$_GET['action'] == 'qiwi_del'
	):

	$db->delete("DELETE FROM payment_qiwi WHERE id_shop = ?", array($get_shop['id']));
	header('Location: /shops/settings/'.$_GET['shop'].'/payment/');
endif;
// Удаляем qiwi



// Добавляем yandex
if (
	!$get_yandex and 
	!empty($_GET['action']) and 
	$_GET['action'] == 'add_yandex'
	):

	// Генерируем URL для авторизации
	$ym = new YandexMoney(YD_CLIENT_ID);
	$toke = $ym->authorizeUri(YD_CLIENT_ID,YD_REDIRECT_URI);
	$_SESSION['yd']['shop_id'] = $get_shop['id'];
	header('Location: '.$toke);
	exit;
	// Генерируем URL для авторизации

endif;
// Добавляем yandex

// Удаляем yandex
if (
	!empty($_GET['action']) and 
	$_GET['action'] == 'yandex_del'
	):

	$db->delete("DELETE FROM payment_yandex WHERE id_shop = ?", array($get_shop['id']));
	header('Location: /shops/settings/'.$_GET['shop'].'/payment/');
endif;
// Удаляем yandex


// Добавляем webmoney
if (
	!$get_webmoney and 
	!empty($_POST['token']) and 
	$tk->check($_POST['token']) and 
	$check_values->check('wmid','post','regexp','~^[0-9]{12}$~') and 
	$check_values->check('wmz','post','regexp','~^Z[0-9]{12}$~') and 
	$check_values->check('wmr','post','regexp','~^R[0-9]{12}$~') and 
	!empty($_POST['wmpassword']) and 
	!empty($_FILES) and 
	$_FILES['keyfile']['type'] == 'application/octet-stream'
	):

	$wm = new webmoney();
	$key = $_FILES['keyfile']['tmp_name'];
	$check_login = $wm->checkwm($_POST['wmid'], $_POST['wmpassword'], $key, $_POST['wmr']); // Какой кошелёк не имеет разницы - это просто проверка авторизации

	if ($check_login):
		$upload = move_uploaded_file($_FILES['keyfile']['tmp_name'], $_SERVER['DOCUMENT_ROOT'].'/class/wm_keys/'.$_POST['wmid'].'_'.$get_shop['id'].'_key.kwm');
		if ($upload):
			$db->insert("INSERT INTO payment_webmoney (id_shop, wmid, wmr, wmz, key_pass) VALUES (?, ?, ?, ?, ?)", array($get_shop['id'], $_POST['wmid'], $_POST['wmr'], $_POST['wmz'], $_POST['wmpassword']));
			header('Location: /shops/settings/'.$_GET['shop'].'/payment/');
		endif;
	endif;

endif;
// Добавляем webmoney


// Удаляем webmoney
if (
	!empty($_GET['action']) and 
	$_GET['action'] == 'webmoney_del'
	):



	$db->delete("DELETE FROM payment_webmoney WHERE id_shop = ?", array($get_shop['id']));
	unlink($_SERVER['DOCUMENT_ROOT'].'/class/wm_keys/'.$get_webmoney['wmid'].'_'.$get_shop['id'].'_key.kwm');
	header('Location: /shops/settings/'.$_GET['shop'].'/payment/');
endif;
// Удаляем webmoney



$token = $tk->input();
require $_SERVER["DOCUMENT_ROOT"].'/template/general/shop/payment.tpl';