$(function(){

    $( document ).tooltip({
        items: "[data-tooltip]",
        content: function() {
            return $(this).attr('data-tooltip');
        },
        tooltipClass: "deertip",
        track: true
    });

	$(document).on('click', 'input.clipboard', function(){
		this.select();
	});

    $(document).on('click', '.order_popup h4 .close', function(){
        $('.order_popup').remove();
        $('table.shop_form input[type="submit"]').attr('disabled', false);
    });

	function validateEmail(email){
		var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	}

	// Создание заказа
	$(document).on('submit', '#order', function(event){
		var link = $(this).attr('action'),
			email = $('input[name=email]', this).val(),
			count = $('input[name=count]', this).val() || 0,
			select_type = $('select[name=type]', this).val(),
			opt = $('option[value="' + select_type + '"]'),
			min_count = opt.attr('data-min_count'),
			paym = $('#paymethod').val(),
			count_accs = opt.attr('data-count');

		/*if (countAccs % 10 != '0')
		{
			var err = 'Кол-во аккаунтов должно быть кратно 10';
			return false;
		}*/

		if (!validateEmail(email))
		{
			alert('Укажите Email адрес');
			return false;
		}

		if (parseInt(count) < parseInt(min_count))
		{
			alert('Мин. кол-во аккаунтов ' + min_count);
			return false;
		}

		if (parseInt(count_accs) < parseInt(count))
		{
			alert('Такого количества аккаунтов нет');
			return false;
		}

        if (paym == 0)
        {
            alert('Выберите способ оплаты');
            return false;
        }

		$.post(link, $(this).serialize(), function(json){
			if (json.order)
			{
                $('table.shop_form input[type="submit"]').attr('disabled', true);
				$('.page_shop_index').append(json.order);
			}
			else
			if (json.errors)
			{
				if (json.errors.global)
					alert(json.errors.global);
				else
				if (json.errors.pay)
					alert(json.errors.pay);
			}
		}, 'json');

		event.preventDefault();
	});

    var hasLink = '';
	// Проверка оплаты товара
	$(document).on('submit', '#pay', function(event){
		var chk = $('.check_pay .check'),
			link = $(this).attr('action');

		chk.addClass('loading').html('');

		$.post(link, $(this).serialize(), function(json){
			chk.removeClass('loading');

			if ((json.ok && json.link) || hasLink != '')
			{
                hasLink = json.link || hasLink;
				$('.check_pay .check').html(hasLink);
			}
            else
			if (json.errors)
			{
				if (json.errors.global)
					$('.check_pay .check').html(json.errors.global);
			}
		}, 'json');


		event.preventDefault();
	});
});